unit uDop;
interface
uses uMain,Classes,uSet,Inifiles,SysUtils,ShellAPI,Windows;
type
  TUser=record//  ,     
    A:string;
    AType:byte; //0-IP 1-Host
    Name:string;//      
  end;
  PUser=^TUser;

  TUsers=class//   
  private     //     , , 
    List:TList;
    BaseName:string;//    
    Ini:TIniFile;
    function GetUser(ind: byte): TUser;
    function GetUsrCnt: byte;
  public
    property UsersCount:byte read GetUsrCnt;
    property User[ind:byte]:TUser read GetUser;
    procedure AddUser(Addr:string;AddrType:byte);
    procedure DelUser(ind:byte);
    constructor create;
    procedure free;
  end;
  TCustUsers=class(TUsers)// ,   
  public
    procedure LoadUserList;
    procedure SaveUserList;
  end;
var
  Users:TUsers;
  CustUsers:TCustUsers;

  procedure PingUsers(s:string;subj:byte);

implementation

{ TUsers }

procedure TUsers.AddUser(Addr: string; AddrType: byte);
begin
  List.Add(New(PUser));
  TUser(List.Items[List.Count-1]^).A:=Addr;
  TUser(List.Items[List.Count-1]^).AType:=AddrType;
  TUser(List.Items[List.Count-1]^).Name:='';
end;

constructor TUsers.create;
begin
  inherited;
  List:=TList.Create;
  BaseName:=Settings.ProgDir+'\Users.ini';
end;

procedure TUsers.DelUser(ind: byte);
begin
  List.Delete(ind);
end;

procedure TUsers.free;
begin
  List.Free;
  inherited;
end;

function TUsers.GetUser(ind: byte): TUser;
begin
  Result:=TUser(List.Items[Ind]^);
end;

function TUsers.GetUsrCnt: byte;
begin
  Result:=List.Count;
end;

procedure TCustUsers.LoadUserList;
var i,max:byte;
begin
  ini:=TIniFile.Create(BaseName);
  max:=ini.ReadInteger('General','UsersCount',0);
  if max<>0 then
  for i:=1 to max do begin
  AddUser(ini.ReadString('User#'+inttostr(i),'Addr','localhost'),
          ini.ReadInteger('User#'+inttostr(i),'Type',1));
  TUser(List.Items[List.Count-1]^).Name:='';
  end;
  ini.Free;
end;

procedure TCustUsers.SaveUserList;
var i:byte;
begin
  ini:=TIniFile.Create(BaseName);
  ini.WriteInteger('General','UsersCount',List.Count);
  if List.Count<>0 then
  for i:=0 to List.Count-1 do begin
    ini.WriteString('User#'+inttostr(i+1),'Addr',GetUser(i).A);
    ini.WriteInteger('User#'+inttostr(i+1),'Type',GetUser(i).AType);
  end;
  ini.Free;
end;

procedure PingUsers(s:string;subj:byte);
begin
  ShellExecute(0,nil,'LANsend',
  PAnsiChar(s+' 10 '+'@Ping'+inttostr(subj)+Settings.NickName),
  nil,SW_NORMAL);
end;

end.
